using System;
using System.Collections.Generic;
using System.Text;

namespace Amazon2
{
    public class Content
    {
        protected string myName, myValue;

        public virtual string Name
        {
            get { return myName; }
        }

        public virtual string Value
        {
            get { return myValue; }
        }

        public override string ToString()
        {
            return Value;
        }

        public Content(string name, string value)
        {
            myName = name; myValue = value;
        }
    }

    public class SearchIndex
    {
        public static readonly Store Blended = new Store("Blended", "ׂ", SearchParameter.Blended, SearchSort.Blended);
        public static readonly Store Books = new Store("Books", "a", SearchParameter.Books, SearchSort.Books);
        public static readonly Store Classical = new Store("Classical", "NVbNy", SearchParameter.Classical, SearchSort.Classical);
        public static readonly Store DVD = new Store("DVD", "DVD", SearchParameter.DVD, SearchSort.DVD);
        public static readonly Store Electronics = new Store("Electronics", "GNgjNX", SearchParameter.Electronics, SearchSort.Electronics);
        public static readonly Store ForeignBooks = new Store("ForeignBooks", "m", SearchParameter.ForeignBooks, SearchSort.ForeignBooks);
        public static readonly Store HealthPersonalCare = new Store("HealthPersonalCare", "wXr[eB[", SearchParameter.HealthPersonalCare, SearchSort.HealthPersonalCare);
        public static readonly Store Hobbies = new Store("Hobbies", "zr[", SearchParameter.Hobbies, SearchSort.Hobbies);
        public static readonly Store Kitchen = new Store("Kitchen", "z[Lb`", SearchParameter.Kitchen, SearchSort.Kitchen);
        public static readonly Store Music = new Store("Music", "y", SearchParameter.Music, SearchSort.Music);
        public static readonly Store MusicTracks = new Store("MusicTracks", "Ȗ", SearchParameter.MusicTracks, SearchSort.MusicTracks);
        public static readonly Store Software = new Store("Software", "\tgEFA", SearchParameter.Software, SearchSort.Software);
        public static readonly Store SportingGoods = new Store("SportingGoods", "X|[cObY", SearchParameter.SportingGoods, SearchSort.SportingGoods);
        public static readonly Store Toys = new Store("Toys", "", SearchParameter.Toys, SearchSort.Toys);
        public static readonly Store VHS = new Store("VHS", "VHS", SearchParameter.VHS, SearchSort.VHS);
        public static readonly Store Video = new Store("Video", "rfI", SearchParameter.Video, SearchSort.Video);
        public static readonly Store VideoGames = new Store("VideoGames", "Q[", SearchParameter.VideoGames, SearchSort.VideoGames);

        protected static readonly Store[] myAll = { Blended, Books, ForeignBooks, Music, 
                Classical, MusicTracks, DVD, VHS, Video, VideoGames, Electronics,
                Software, Toys, Hobbies, SportingGoods, Kitchen, HealthPersonalCare };

        public static Content[] All
        {
            get { return myAll; }
        }
    }

    public class Store : Content
    {
        protected Content[] myParameters, mySorts;

        public Content[] Parameters
        {
            get { return myParameters; }
        }

        public Content[] Sorts
        {
            get { return mySorts; }
        }

        public Store(string name, string value, Content[] prms, Content[] sorts)
            : base(name, value)
        {
            myParameters = prms; mySorts = sorts;
        }
    }

        public class SearchSort      /*  U ͏AL ͍~\ */
    {
        public static readonly Content Empty = new Content("", "я͎wł܂B");
        public static readonly Content DateL = new Content("daterank", "t̐V̂");
        public static readonly Content MinAgeU = new Content("mfg-age-min", "ŏΏ۔N̏Ȃ̂");
        public static readonly Content MinAgeL = new Content("-mfg-age-min", "ŏΏ۔N̑傫Ȃ̂");
        public static readonly Content Price1U = new Content("pricerank", "lï̂");
        public static readonly Content Price1L = new Content("-pricerank", "li̍̂");
        public static readonly Content PriceL = new Content("inverse-pricerank", "li̍̂");
        public static readonly Content Price2U = new Content("price", "lï̂");
        public static readonly Content Price2L = new Content("-price", "li̍̂");
        public static readonly Content RelDate1U = new Content("orig-rel-date", "̌Â̂");
        public static readonly Content RelDate1L = new Content("-orig-rel-date", "̐V̂");
        public static readonly Content RelDate2U = new Content("release-date", "̌Â̂");
        public static readonly Content RelDate2L = new Content("-release-date", "̐V̂");
        public static readonly Content SalesL = new Content("salesrank", "グ̍̂");
        public static readonly Content TitleU = new Content("titlerank", "^CgiABCj");
        public static readonly Content TitleL = new Content("-titlerank", "^Cg~iZYXj");

        public static readonly Content[] Blended = { Empty };
        public static readonly Content[] Books = { SalesL, Price1U, PriceL, TitleU, TitleL, DateL };
        public static readonly Content[] Classical = { SalesL, Price1U, Price1L, TitleU, TitleL, RelDate1U, RelDate1L };
        public static readonly Content[] DVD = { SalesL, Price1U, Price1L, TitleU, TitleL, RelDate1U, RelDate1L };
        public static readonly Content[] Electronics = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L };
        public static readonly Content[] ForeignBooks = { SalesL, Price1U, PriceL, TitleU, TitleL, DateL };
        public static readonly Content[] HealthPersonalCare = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L };
        public static readonly Content[] Hobbies = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L, MinAgeU, MinAgeL };
        public static readonly Content[] Kitchen = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L };
        public static readonly Content[] Music = { SalesL, Price1U, Price1L, TitleU, TitleL, RelDate1U, RelDate1L };
        public static readonly Content[] MusicTracks = { TitleU, TitleL };
        public static readonly Content[] Software = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L };
        public static readonly Content[] SportingGoods = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L };
        public static readonly Content[] Toys = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L };
        public static readonly Content[] VHS = { SalesL, Price1U, Price1L, TitleU, TitleL, RelDate1U, RelDate1L };
        public static readonly Content[] Video = { SalesL, Price1U, Price1L, TitleU, TitleL, RelDate1U, RelDate1L };
        public static readonly Content[] VideoGames = { SalesL, Price2U, Price2L, TitleU, TitleL, RelDate2U, RelDate2L };
    }

}
