using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using XmlRpc;

namespace BlogList
{
    public partial class Form1 : Form
    {
        public const string CocoUrl = "http://app.f.cocolog-nifty.com/t/api";

        private string userId, userPassword;
        private BlogInfo userBlogInfo;

        public Form1()
        {
            InitializeComponent();
        }

        private void settingButton_Click(object sender, EventArgs e)
        {
            using (Form2 userDialog = new Form2())
            {
                userDialog.userId = userId;
                userDialog.userPassword = userPassword;
                userDialog.userBlog = userBlogInfo;
                    
                if (userDialog.ShowDialog() == DialogResult.OK)
                {
                    userId = userDialog.userId;
                    userPassword = userDialog.userPassword;
                    userBlogInfo = userDialog.userBlog;
                }
            }
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            if (userBlogInfo == null)
            {
                MessageBox.Show("[U[ݒsĂ", Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            listView1.Items.Clear();

            try
            {
                XmlRpcGetRecentPosts getPostsMethod = new
                    XmlRpcGetRecentPosts(CocoUrl, userBlogInfo.BlogId,
                    userId, userPassword, (int)numericUpDown1.Value);
                List<BlogArticle> myBlogList = getPostsMethod.Request();
                responseTextBox.Text = getPostsMethod.ResponseXmlText;
                requestTextBox.Text = getPostsMethod.RequestXmlText;

                foreach (BlogArticle x in myBlogList)
                {
                    BlogArticleItem blogItem = new BlogArticleItem();
                    blogItem.Item = x;
                    listView1.Items.Add(blogItem);
                }
            }
            catch
            {
                MessageBox.Show("L̎擾Ɏs܂", Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
            }        
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count > 0)
            {
                BlogArticleItem blogItem = listView1.SelectedItems[0] as BlogArticleItem;
                webBrowser1.DocumentText = blogItem.Item.Description;
                contentsTextBox.Text = blogItem.Item.Description;
            }
        }
    }
}