using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace Dom2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            XmlDocument myDoc = new XmlDocument();
            string fileName = Path.Combine(
                Application.StartupPath, "Cdlist.xml");
            myDoc.Load(fileName);

            XmlNodeList tracks =
                myDoc.GetElementsByTagName("Track");

            foreach (XmlNode currentNode in tracks)
            {
                Track myTrack = new Track();
                myTrack.Title = currentNode["Title",
                    "http://www.kkasahara.com/cd"].InnerText;
                myTrack.Artist = currentNode["Artist",
                    "http://www.kkasahara.com/cd"].InnerText;
                myTrack.Music = currentNode["Music"].InnerText;
                myTrack.Lyrics = currentNode["Lyrics"].InnerText;
                myTrack.Arranged = currentNode["Arranged"].InnerText;
                myTrack.No =
                    int.Parse(currentNode.Attributes["No"].Value);
                myTrack.Playtime = TimeSpan.Parse(
                    currentNode["Playtime"].InnerText);
                myTrack.AlbumName = currentNode.ParentNode[
                    "Title"].InnerText;
                listBox1.Items.Add(myTrack);
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Track selected = (Track)listBox1.SelectedItem;
            albumLabel.Text = selected.AlbumName;
            arrangedLabel.Text = selected.Arranged;
            lyricsLabel.Text = selected.Lyrics;
            musicLabel.Text = selected.Music;
            playtimeLabel.Text = selected.Playtime.ToString();
            titleLabel.Text = selected.Title;
        }
    }

    public class Track
    {
        private string title, artist, music, lyrics, arranged,
            albumname;
        private int no;
        private TimeSpan playtime;

        public string Title
        {
            get { return title; }
            set { title = value; }
        }

        public string Artist
        {
            get { return artist; }
            set { artist = value; }
        }

        public string Music
        {
            get { return music; }
            set { music = value; }
        }

        public string AlbumName
        {
            get { return albumname; }
            set { albumname = value; }
        }

        public string Lyrics
        {
            get { return lyrics; }
            set { lyrics = value; }
        }

        public string Arranged
        {
            get { return arranged; }
            set { arranged = value; }
        }

        public int No
        {
            get { return no; }
            set { no = value; }
        }

        public TimeSpan Playtime
        {
            get { return playtime; }
            set { playtime = value; }
        }

        public override string ToString()
        {
            return Title;
        }
    }
}