using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace Dom3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            XmlDocument myDoc = new XmlDocument();
            XmlNode xmlDeclaration =
                myDoc.CreateXmlDeclaration("1.0", "utf-8", null);
            XmlNode cdList = myDoc.CreateElement("CDList");

            XmlAttribute cdns =
                myDoc.CreateAttribute("xmlns:cdns");
            cdns.Value = "http://www.kkasahara.com/cd";

            cdList.Attributes.Append(cdns);

            XmlNode cd = myDoc.CreateElement("CD");

            string textFileName = Path.Combine(
                Application.StartupPath, "Cdlist.txt");
            StreamReader myReader = new
                StreamReader(textFileName);

            XmlNode cdTitle =
                cd.AppendChild(myDoc.CreateElement("Title"));
            cdTitle.InnerText = myReader.ReadLine();
            XmlNode cdArtist =
                cd.AppendChild(myDoc.CreateElement("Artist"));
            cdArtist.InnerText = myReader.ReadLine();
            XmlNode cdRelease =
                cd.AppendChild(myDoc.CreateElement("ReleaseDate"));
            cdRelease.InnerText = myReader.ReadLine();

            string lineBuffer;

            for (int no = 1; (lineBuffer = myReader.ReadLine()) != null; no++)
            {
                string[] columns = lineBuffer.Split('\t');
                XmlNode track = myDoc.CreateElement("Track");
                XmlAttribute number =
                    myDoc.CreateAttribute("No");
                number.InnerText = no.ToString();
                track.Attributes.Append(number);

                XmlNode trackArtist = track.AppendChild(myDoc.CreateElement(
                    "cdns:Artist",
                    "http://www.kkasahara.com/cd"));
                trackArtist.InnerText = columns[1];
                XmlNode trackTitle =
                    track.AppendChild(myDoc.CreateElement(
                    "cdns:Title",
                    "http://www.kkasahara.com/cd"));
                trackTitle.InnerText = columns[0];
                XmlNode trackMusic =
                    track.AppendChild(myDoc.CreateElement(
                    "Music"));
                trackMusic.InnerText = columns[2];
                XmlNode trackLyrics = track.AppendChild(myDoc.CreateElement(
                    "Lyrics"));
                trackLyrics.InnerText = columns[3];
                XmlNode trackArranged = track.AppendChild(myDoc.CreateElement(
                    "Arranged"));
                trackArranged.InnerText = columns[4];
                XmlNode trackTime =
                    track.AppendChild(myDoc.CreateElement(
                    "Playtime"));
                trackTime.InnerText = columns[5];
                cd.AppendChild(track);
            }

            myReader.Close();

            cdList.AppendChild(cd);
            myDoc.AppendChild(xmlDeclaration);
            myDoc.AppendChild(cdList);
            string xmlFileName = Path.Combine(
                Application.StartupPath, "Cdlist.xml");
            myDoc.Save(xmlFileName);

            messageLabel.Text = "t@C쐬܂";
        }
    }
}