using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Web;
using System.IO;
using System.Collections.Specialized;
using System.Diagnostics;

namespace GAuth
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            GoogleAuth myAuth = new GoogleAuth(emailTextBox.Text, passwordTextBox.Text, "cl");
            if (myAuth.RequestAuth())
                resultTextBox.Text = "F؂ɐ܂\r\n" + myAuth.AuthToken;
            else
                resultTextBox.Text = "F؂Ɏs܂\r\n" + myAuth.ErrorCode;

            if (myAuth.ErrorCode == "CaptchaRequired")
                Process.Start("https://www.google.com/accounts/DisplayUnlockCaptcha");
        }
    }

    public class GoogleAuth
    {
        private string email, password;
        private string servicecode, authtoken, errorcode;

        const string authUrl = "https://www.google.com/accounts/ClientLogin";
        const string appName = "PHL-GAuthApp-100";

        public string AuthToken
        {
            get { return authtoken; }
            private set { authtoken = value; }
        }

        public string ErrorCode
        {
            get { return errorcode; }
            private set { errorcode = value; }
        }

        public GoogleAuth(string m, string p,string s)
        {
            email = m;
            password = p;
            servicecode = s;
        }

        private WebRequest PostRequest(string url, NameValueCollection sendData, Encoding textEncoding)
        {
            WebRequest myRequest = WebRequest.Create(url);
            myRequest.Method = "POST";
            myRequest.ContentType = "application/x-www-form-urlencoded";

            string requestString = "";

            for (int i = 0; i < sendData.Count; i++)
            {
                if (i != 0)
                    requestString += "&";
                requestString += HttpUtility.UrlEncode(sendData.Keys[i], textEncoding) + "=" + HttpUtility.UrlEncode(sendData[i], textEncoding);
            }

            StreamWriter myStreamWriter = new StreamWriter(myRequest.GetRequestStream(), Encoding.ASCII);
            myStreamWriter.Write(requestString);
            myStreamWriter.Close();

            return myRequest;
        }

        public bool RequestAuth()
        {

            NameValueCollection authParameter = new NameValueCollection();

            authParameter.Add("Email", email);
            authParameter.Add("Passwd", password);
            authParameter.Add("service", servicecode);
            authParameter.Add("source", appName);

            WebRequest myRequest = null;
            HttpWebResponse myResponse = null;
            
            try
            {
                myRequest = PostRequest(authUrl, authParameter, Encoding.ASCII);
                myResponse = (HttpWebResponse)myRequest.GetResponse();
            }
            catch (WebException ex)
            {
                if (ex.Status == WebExceptionStatus.ProtocolError)
                    myResponse = (HttpWebResponse)ex.Response;
            }

            if (myResponse != null)
            {
                StreamReader sr = new StreamReader(myResponse.GetResponseStream());

                string buffer = null;
                
                while ((buffer = sr.ReadLine()) != null)
                {
                    if (buffer.StartsWith("Auth="))
                        AuthToken = buffer.Substring(5);
                    if (buffer.StartsWith("Error="))
                        ErrorCode = buffer.Substring(6);
                }

                myResponse.Close();
            }
            return (myResponse != null && myResponse.StatusCode == HttpStatusCode.OK);
        }
    }
}