using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Text.RegularExpressions;

namespace HttpDownload2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            WebClient myClient = new WebClient();
            byte[] contents =
                myClient.DownloadData(urlTextBox.Text);
            Encoding contentEncoding;

            if (sjisRadioButton.Checked)
                contentEncoding =
                    Encoding.GetEncoding("shift_jis");
            else if (eucRadioButton.Checked)
                contentEncoding =
                    Encoding.GetEncoding("euc-jp");
            else if (utf8RadioButton.Checked)
                contentEncoding = Encoding.GetEncoding("utf-8");
            else
                contentEncoding = DetectEncoding(contents);

            htmlTextBox.Text =
                contentEncoding.GetString(contents);
            encodeLabel.Text = contentEncoding.WebName;
        }

        private Encoding DetectEncoding(byte[] contents)
        {
            string s = Encoding.ASCII.GetString(contents);

            Match myMatch = Regex.Match(s, 
                @"<meta\s+[^>]*charset\s*=\s*([-_\w]+)", 
                RegexOptions.IgnoreCase);
            string e = myMatch.Success ? myMatch.Groups[1].Value : 
                "shift_jis";
            return Encoding.GetEncoding(e);
        }
    }
}