using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using LiveSearch1.com.msn.search.soap;

namespace LiveSearch1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string appId;

        private void goButton_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            MSNSearchService searchService = new MSNSearchService();

            string queryText = keywordTextBox.Text;

            if (jaCheckBox.Checked)
                queryText += " language:ja";

            SourceRequest sr = new SourceRequest();
            sr.Source = SourceType.Web;
            sr.Offset = 0;
            sr.Count = 50;
            SearchRequest mySearchRequest = new SearchRequest();
            mySearchRequest.Requests = new SourceRequest[] { sr };

            if (appId.Length == 0)
            {
                MessageBox.Show("AvP[VIDݒ肵Ă", Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            
            mySearchRequest.AppID = appId;
            mySearchRequest.Query = queryText;
            mySearchRequest.CultureInfo = "ja-JP";

            SearchResponse searchResponse = null;
            try
            {
                searchResponse = searchService.Search(mySearchRequest);
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message, Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            SourceResponse sourceResponse = searchResponse.Responses[0];

            Result[] sourceResults = sourceResponse.Results;

            listView1.BeginUpdate();

            foreach (Result sourceResult in sourceResults)
            {
                SearchResultListViewItem lvItem = new
                    SearchResultListViewItem(sourceResult);
                listView1.Items.Add(lvItem);
            }

            listView1.EndUpdate();
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count > 0)
            {
                Process.Start(((SearchResultListViewItem)listView1.SelectedItems[0]).Result.Url);
            }
        }

        private void settingButton_Click(object sender, EventArgs e)
        {
            using (Form2 idDialog = new Form2())
            {
                idDialog.ApplicationID = appId;

                if (idDialog.ShowDialog() == DialogResult.OK)
                {
                    appId = idDialog.ApplicationID;
                    Properties.Settings.Default.ApplicationId = appId;
                    Properties.Settings.Default.Save();
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            appId = Properties.Settings.Default.ApplicationId;
        }
    }

    public class SearchResultListViewItem : ListViewItem
    {
        private Result innerResult;

        public SearchResultListViewItem(Result r)
        {
            innerResult = r;
            Text = r.Title;
            SubItems.Add(r.Description);
        }

        public Result Result
        {
            get { return innerResult; }
        }
    }
}