using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace XmlReader1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();

            string fileName = Path.Combine(
                Application.StartupPath, "Cdlist.xml");
            XmlReader myReader = XmlReader.Create(fileName);

            ListViewItem currentItem = new ListViewItem();

            while (myReader.Read())
            {
                if (myReader.Name == "CD")
                {
                    switch (myReader.NodeType)
                    {
                        case XmlNodeType.Element:
                            currentItem = new ListViewItem();
                            currentItem.SubItems.AddRange(new
                                string[] { "", "" });
                            break;
                        case XmlNodeType.EndElement:
                            listView1.Items.Add(currentItem);
                            currentItem = null;
                            break;
                    }
                }
                else if (currentItem != null && myReader.NodeType ==
                    XmlNodeType.Element)
                {
                    switch (myReader.Name)
                    {
                        case "Title":
                            currentItem.Text =
                                myReader.ReadString();
                            break;
                        case "Artist":
                            currentItem.SubItems[1].Text =
                                myReader.ReadString();
                            break;
                        case "ReleaseDate":
                            currentItem.SubItems[2].Text =
                                myReader.ReadString();
                            break;
                    }
                }
            }
            myReader.Close();
        }
    }
}