using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace XmlWriter1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            XmlWriterSettings mySettings = new
                XmlWriterSettings();
            mySettings.Indent = true;
            string xmlFileName = Path.Combine(
                Application.StartupPath, "Cdlist.xml");
            XmlWriter myXmlWriter = XmlWriter.Create(
                xmlFileName, mySettings);

            string textFileName = Path.Combine(
                Application.StartupPath, "Cdlist.txt");
            StreamReader myReader =
                new StreamReader(textFileName);

            myXmlWriter.WriteStartElement("CDList");
            
            myXmlWriter.WriteAttributeString("xmlns", "cdns",
                null, "http://www.kkasahara.com/cd");
                        
            myXmlWriter.WriteStartElement("CD");
            
            myXmlWriter.WriteElementString("Title",
                myReader.ReadLine());
            myXmlWriter.WriteElementString("Artist",
                myReader.ReadLine());
            myXmlWriter.WriteElementString("ReleaseDate",
                myReader.ReadLine());

            string lineBuffer;

            for (int no = 1; (lineBuffer = myReader.ReadLine()) !=
                null; no++)
            {
                string[] columns = lineBuffer.Split('\t');

                myXmlWriter.WriteStartElement("Track");
                myXmlWriter.WriteAttributeString("No",
                    no.ToString());

                myXmlWriter.WriteElementString("cdns", "Artist",
                    "http://www.kkasahara.com/cd", columns[1]);
                myXmlWriter.WriteElementString("cdns", "Title",
                    "http://www.kkasahara.com/cd", columns[0]);
                myXmlWriter.WriteElementString("Music",
                    columns[2]);
                myXmlWriter.WriteElementString("Lyrics",
                    columns[3]);
                myXmlWriter.WriteElementString("Arranged",
                    columns[4]);
                myXmlWriter.WriteElementString("Playtime",
                    columns[5]);

                myXmlWriter.WriteEndElement();
            }

            myXmlWriter.WriteEndElement();

            myXmlWriter.WriteEndElement();

            myReader.Close();
            myXmlWriter.Close();

            messageLabel.Text = "t@C쐬܂";
        }
    }
}